# WP Data Access

* Contributors: peterschulznl, maxxschulz, kimmyx, aaronvincentlee
* Tags: table builder, form builder, datatable, datatables, data table, data tables, table, tables, responsive tables, dynamic tables, sortable tables, csv, json, xml, remote database, remote databases, large tables, big tables, spreadsheet, google sheets, charts, data, database, business intelligence
* Donate link: https://www.paypal.me/kpsch
* Requires at least: WordPress 4.8.3
* Tested up to: WordPress 6.2
* Stable tag: 5.3.8
* License: GPLv2 or later
* License URI: http://www.gnu.org/licenses/gpl-2.0.html

The best WordPress table plugin with an intuitive table builder and a highly customizable form builder

## Description
Create professional responsive data tables within minutes. An intuitive table builder supports many features on mouse click and layout and behavior changes of almost any element of a DataTable through an advanced options section. Data tables are based on the famous DataTables plugin for jQuery supporting any database table size.

Use the form builder to create highly customizable data apps for back-end and front-end. Customization is supported through templates, supporting many features like master-detail pages, lookups, inline editing, advanced search features, dynamic hyperlinks, WordPress role management integration and many more.

Manage data and databases with the user-friendly Data Explorer or use the Query Builder to write SQL queries from the WordPress dashboard. Remote database access to MariaDB and MySQL is available for all versions. Premium users can access foreign databases like SQL Server, PostgreSQL, Oracle and MS Access through our premium proxy server and auto sync CSV (including Google Sheets), JSON and XML files.

### Data Tables
> Intuitive table builder to create professional data tables for back-end and front-end in minutes

* Easy to use, highly customizable
* Fully responsive
* Many styling options including an intuitive [Style Manager](https://wpdataaccess.com/docs/data-tables/extension-manager/)
* [Many searching and sorting algorithms](https://wpdataaccess.com/docs/data-explorer-settings/search-settings/)
* Many static and interactive filters ([search panes](https://wpdataaccess.com/search-panes-demo-without-buttons/), [search forms](https://wpdataaccess.com/publication-search-form-demo/), [search builder](https://wpdataaccess.com/search-builder-demo/) and [more](https://wpdataaccess.com/docs/data-tables-demos-and-tutorials/data-tables-demos/))
* Server-side processing (supporting very large tables)
* Client-side processing (great for fast searching and sorting of small tables)
* [Export to CSV, Excel, PDF and SQL](https://wpdataaccess.com/export-buttons-demo/)
* [Fully customizable and programmable buttons](https://wpdataaccess.com/docs/data-tables-buttons/data-tables-custom-buttons/)
* [Integrated geolocation search](https://wpdataaccess.com/publication-using-geolocation/)
* Custom queries and custom post types

### Data Apps
> Data Projects is a form builder that helps to create highly customizable data driven WordPress apps for back-end and front-end

* Auto generated CRUD pages
* [Highly customizable through Project Templates](https://wpdataaccess.com/docs/data-apps/projects-and-templates/)
* Lookups (supporting drop-down lists and autocomplete fields)
* Master-detail pages
* Turn Data Projects into state of the art responsive apps with [Data Forms](https://wpdataaccess.com/data-forms-project-demo/)
* [Inline editing](https://wpdataaccess.com/docs/data-explorer-settings/search-settings/)
* [Many advanced search features](https://wpdataaccess.com/docs/data-explorer-settings/search-settings/)
* WordPress role integration
* WordPress media library integration

### Data Management
> The Data Explorer helps WordPress users to manage local and remote data and databases directly from the WordPress dashboard

* Manage local and remote data and databases
* Global search and replace on multiple databases and tables
* [Import SQL and CSV files (supports ZIP for large import files)](https://wpdataaccess.com/docs/data-explorer-manage/imports-sql-csv/)
* [Exports to SQL, CSV, JSON and XML (supports extremely large table exports)](https://wpdataaccess.com/docs/data-explorer-actions/actions/)
* Rename, copy, truncate, drop, optimize and alter tables
* [Manage table and column settings (advanced search, geolocation, inline editing and more)](https://wpdataaccess.com/docs/data-explorer-settings/table-and-view-settings/)

### Remote Databases and Remote Data Files
> Connect to remote databases and auto sync remote data files

* Remote databases and remote data files are available to all plugin tools
* [A premium remote connection wizard helps to setup connections to:](https://wpdataaccess.com/docs/remote-connection-wizard/remote-connection-wizard/)
  * Remote databases: SQL Server, Oracle, PostgreSQL, MariaDB, MySQL and MS Access (file based)
  * Remote data files: CSV, JSON and XML files ([e.g. sync Google Sheets](https://wpdataaccess.com/docs/remote-data-files/public-url/#google-sheets))

### Query Builder
> Execute SQL queries directly from the WordPress dashboard

* [Work on multiple SQL queries simultaneously using tabs](https://wpdataaccess.com/docs/query-builder/query-builder-tutorials/)
* Save and reuse queries (for data tables and charts)
* Protects WordPress table structures and data
* Interactive [Visual Query Builder](https://wpdataaccess.com/docs/query-builder/visual-query-builder/) for user with limited or no SQL knowledge

### Dashboards and Widgets
> Widgets are highly customizable and can be shown on dashboards (back-end), webpages (front-end), and external websites

* Manage all your data in one location
* Share your data widgets anywhere (back-end, font-end and other websites)
* Give specific users and user groups access to locked dashboards
* Allow users to create their own dashboards
* Low cost Business Intelligence solution

### Geolocation search
> Create a searchable geolocation map from a database table

* Google Maps integration
* Many customizable settings per database table
* [DataTables integration](https://wpdataaccess.com/publication-using-geolocation/)
* [Search map within adjustable radius](https://wpdataaccess.com/demos/geolocation-demo/)

### Charts
> Charts builder for creating charts from SQL queries

* Google Charts integration
* Query Builder integration
* Visual Query Builder integration for users with little or no SQL knowledge
* [Many chart types directly selectable from drop-down list](https://wpdataaccess.com/2022/06/16/chart-demo/)

### Data Designer
> Create tables and indexes using an intuitive user interface

* Create tables and indexes
* Modify tables and indexes
* Supports reverse engineering and reconciliation

### Plugin Settings
> Many detailed plugin settings are available to manage the plugin user interface and behavior

## Useful Links
- [Plugin Website](https://wpdataaccess.com/)
- [Documentation](https://wpdataaccess.com/documentation/)
- [Demos](https://wpdataaccess.com/demos/)
- [Tutorials](https://wpdataaccess.com/tutorials/)

## License

WP Data Access is licensed under the [GPL v2](http://www.gnu.org/licenses/gpl-2.0.html) or later.

> This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License, version 2, as
published by the Free Software Foundation.

> This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

> You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
